\input amigatexinfo
\input texinfo
@c %**start of header
@setfilename FlexCat_svenska.guide
@settitle FlexCat @value{VERSION}    Dokumentation
@setchapternewpage off

@c  $VER: FlexCat_svenska.texinfo 2.0
@c
@c  FlexCat:                  The flexible catalog generator
@c  Copyright (C)  1993-1999  Jochen Wiedmann and Marcin Orlowski
@c
@c  This program is free software.
@c
@c  This program is distributed in the hope that it will be useful,
@c  but WITHOUT ANY WARRANTY; without even the implied warranty of
@c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
@c
@c  This file contains the Swedish documentation, translated by
@c  Magnus Holmgren

@set xrefstring se
@set Xrefstring Se
@set Footnotestring Fotnoter
@set Chapterstring Kapitel
@set Appendixstring Appendix
@set Sectionstring Sektion
@set sectionstring sektion
@set pagestring sida

@set VERSION 2.0
@iftex
@parskip=0.75em
@end iftex
@c %**end of header


@titlepage

@title{FlexCat}
@subtitle{Den flexibla kataloggeneratorn}
@subtitle{}
@subtitle{Version @value{VERSION}}
@author Jochen Wiedmann och Marcin Orlowski
@vskip 0pt plus 1filll
@tex
@halign{@hfil#&#@hfil@cr
       Sedan version 1.8 utvecklas FlexCat av:@cr
@cr
       & Marcin Orlowski@cr
       & ul. Radomska 38@cr
       & 71-002 Szczecin@cr
       & Polen@cr
@cr
       & carlos@@amiga.com.pl@cr
       & http://amiga.com.pl/flexcat/@cr
@cr
FlexCat skapades av:@cr
@cr
       & Jochen Wiedmann@cr
       & Am Eisteich 9@cr
       & 72555 Metzingen@cr
       % Tyskland
}
@end tex

Tillstnd har utfrdats fr att gra och distribuera exakta kopior av den
hr manual och av programmet FlexCat.

@ignore
Tillstnd har utfrdats fr att behandla den hr filen med TeX och skriva
ut resultatet, under frutsttning att det utskrivna dokumentet inehller
ett kopieringstillstnd identiskt med detta, med undantag fr borttagandet
av detta stycke (d detta stycke inte r relevant fr den utskrivna
manualen).
@end ignore

Frfattaren utfrdar @strong{inga som helst} garantier fr att programmet
som beskrivs i denna dokumentation, samt resultatet frn programmet, r
korrekta. Frfattaren kan inte hllas ansvarig fr @strong{ngra} skador
som hrrr frn anvndadet av denna mjukvara.
@end titlepage
@iftex
@headings double
@end iftex


@ifinfo
@node Top
@top FlexCat V@value{VERSION} - Dokumentation
Den hr filen beskriver FlexCat version @value{VERSION}, ett program som
genererar kataloger, samt kllkoden fr att anvnda dem. FlexCat liknar
@code{CatComp} och @code{KitCat}, men kan generera vilken kllkod du vill.
Detta sker genom s kallade @code{kllkodsbeskrivningar}, som r mallar fr
den genererade koden. De kan redigeras, och kan slunda anpassas till olika
programsprk samt individuella behov.

@menu
Generellt:

* Anvsvarsfrntagande: Disclaimer.  Upphovsrtt, (INGEN) garanti
* versikt: Survey.                 Vad r FlexCat?
* Installation: Installation.       Hur fr jag det att fungera?

Anvnda FlexCat:

* Programstart: Program start.      Anvnda FlexCat i ett skal
* Instllningar: Preferences.       ndra FlexCats normala beteende
* Katalogbeskrivning: Description.  Katalogbeskrivningar (@key{.cd}-filer)
* Katalogversttning: Translation. Katalogversttningar (@key{.ct}-filer)
* Kllkodsbeskrivning: Source.      Kllkodsbeskrivningar (@key{.sd}-filer)
* Anvnda kllkoden: Using source.  Anvnda kllkoden i egna program

Mindre viktigt:

* Framtid: Future.                  Vidare utveckling av FlexCat
* Support: Support.                 Var uppdateringar kan hittas
* Historia: History.                Utvecklingshistoria
* Tack till: Credits.               Vad jag alltid velat sga@dots{}
* Index: Index.                     Hitta det du aldrig letar efter

@end menu
@end ifinfo





@ifinfo
@node Disclaimer
@chapter Upphovsrtt och anndra rttsliga saker
@cindex Copyright
@cindex Upphovsrtt
@cindex Distribution
@cindex Tillstnd
@cindex Frbud
@cindex Frfattare
@cindex Adress
@cindex Internet
@cindex E-post
@example
Upphovsrtt @copyright{} 1993-1999 Jochen Wiedmann och Marcin Orlowski

        Jochen Wiedmann
        Am Eisteich 9
        72555 Metzingen
        Tyskland

        Sedan version 1.8 utvecklas programmet av

        Marcin Orlowski
        ul. Radomska 38
        71-002 Szczecin
        Polen

        carlos@@amiga.com.pl
        http://amiga.com.pl/flexcat/
@end example

Tillstnd har utfrdats fr att gra och distribuera exakta kopior av den
hr manualen och av programmet FlexCat.

@ignore
Tillstnd har utfrdats fr att behandla den hr filen med TeX och skriva
ut resultatet, under frutsttning att det utskrivna dokumentet inehller
ett kopieringstillstnd identiskt med detta, med undantag fr borttagandet
av detta stycke (d detta stycke inte r relevant fr den utskrivna
manualen).
@end ignore

Frfattaren utfrdar @strong{inga som helst} garantier fr att programmet
som beskrivs i denna dokumentation, samt resultatet frn programmet, r
korrekta. Frfattaren kan inte hllas ansvarig fr @strong{ngra} skador
som hrrr frn anvndadet av denna mjukvara. @end ifinfo


@iftex
@vfill@eject
@end iftex

@node Survey
@chapter versikt
@cindex versikt
I och med OS 2.1 erbjuder Amigan ett trevligt system fr att anvnda
program p olika sprk: @code{locale.library}. (Detta kallas att lokalisera
programmet; det r vad namnet str fr.)

Idn r enkel: Du vljer ett sprk - engelska fr det mesta - och skriver
ditt program p samma stt som du gjorde utan lokalisering, frutom att
konstanta strngar erstts av vissa speciella funktionsanrop. Ett annat
funktionsanrop gr det mjligt fr anvndaren att vlja ett annat sprk nr
programmet krs. (Det senare funktionsanropet lser in en extern fil, den
s kallade @code{katalogen}, och gr att den ovan nmnda funktionen lser
strngarna frn katalogen istllet fr att anvnda de frdefinierade
strngarna.)

Dessa kataloger r oberoende av programmet. Allt du behver fr att lgga
till ett annat sprk r att skapa en ny katalogfil, och detta kan gras nr
som helst, utan att programmet ndras.

Men det r ngra saker till som programmeraren behver gra: Han behver
skapa katalogen, de frdefinierade strngarna, och lite kllkod fr att
anvnda strngarna (de funktioner som nmns ovan). FlexCat har konstruerats
fr att gra detta p ett enkelt och nst intill automatiskt stt, utan att
fr den skull frlora flexibilitet nr det gller skapandet av kllkoden.
Ett exempel fr att frtydliga:

Antag att vi vill skriva @file{HelloLocalWorld.c}. Vrt slutliga program
kommer att se ut s hr:

@example
#include <stdio.h>
#include <stdlib.h>
/* Du @strong{mste} inkludera den hr filen! */
#include <HelloLocalWorld_Cat.h>

void main(int argc, char *argv[])
@{
    printf("%s\n", msgHello);
@}
@end example

@noindent
Observera att detta r mycket likt den ursprungliga @file{HelloWorld.c},
frutom att vi har ersatt strngen "Hello, world!" med konstanten
@code{msgHello}.

Dessa konstanter och de relaterade strngarna definieras i en s kallad
@code{katalogbeskrivning} (@pxref{Description, katalogbeskrivning}). Du
brjar alltid med att skapa en sdan fil, kallad @file{HelloLocalWord.cd},
som kan se ut s hr:

@example
; Kommentarer kan naturligtvis anvndas! Varje rad som
; brjar med ett semikolon antas vara en kommentar.
;
; Sprket fr de inbyggda strngarna:
#language english
;
; Katalogens version. Den anvnd vid anropet av
; Locale/OpenCatalog(). Detta skiljer sig frn
; Exec/OpenLibrary(): 0 betyer vilken katalog som helst,
; medans andra nummer mste stmma exakt!
#version 0
;
; Detta definierar en strng och det ID som anvnds fr att
; ange den. Talet 4 hr sger att strngen inte fr vara
; kortare n 4 tecken.
msgHello (/4/)
Hello, world!
@end example

Genom att anvnda FlexCat skapar du tv filer utifrn katalogbeskrivningen:
Inkluderingsfilen @file{HelloLocaleWorld_Cat.h}, som definierar
konstanterna, samt filen @file{HelloLocalWorld_Cat.c}, som innehller en
vektor med strngar samt ngra initieringsfunktioner. Du behver inte veta
vad funktionerna gr; anvnd dem bara. Du behver framfr allt inte veta
ngot om @code{locale.library}!

Du kanske r intresserad av hur dessa filer ser ut, eller du kanske till
och med vill modifiera dem. Det r hr skillanden mellan FlexCat och andra
kataloggeneratorer mrks: Med FlexCat r du inte bunden till vissa inbyggda
format p dessa filer. Istllet anvnder FlexCat externa mallfiler, s
kallade @code{kllkodsbeskrivningar}. Detta gr det mjligt att till exmpel
anvnda kataloger med AmigaOS 2.0 (@pxref{Source, kllkodsbeskrivning}). Om
du anvnder kllkodsbeskrivningar frn FlexCat-distributionen kan du skapa
kllkodsfiler med fljande kommandon:

@example
@samp{FlexCat HelloLocalWorld.cd HelloLocalWorld_Cat.c=C_c.sd}
@samp{FlexCat HelloLocalWorld.cd HelloLocalWorld_Cat.h=C_h.sd}
@end example

Nr ditt program r klart, kan du anvnda FlexCat fr att skapa s kallade
@code{katalogversttningar}; en versttning fr varje sprk du vill
stdja (frutom det inbyggda sprket). @xref{Translation,
katalogversttning}. Lt oss skapa en tysk katalogversttning fr vrt
exempelprogram:

@example
@samp{FlexCat HelloLocalWorld.cd NEWCTFILE Deutsch.ct}
@end example

@noindent
Den hr filen skulle nu se ut s hr:

@example
## version
## language
## codeset 0
; Kommentarer kan naturligtvis anvndas! Varje rad som
; brjar med ett semikolon antas vara en kommentar.
;
; Sprket fr de inbyggda strngarna:
;
; Katalogens version. Den anvnd vid anropet av
; Locale/OpenCatalog(). Detta skiljer sig frn
; Exec/OpenLibrary(): 0 betyer vilken katalog som helst,
; medans andra nummer mste stmma exakt!
;
; Detta definierar en strng och det ID som anvnds fr att
; ange den. Talet 4 hr sger att strngen inte fr vara
; kortare n 4 tecken.
msgHello

;Hello, world!
@end example

@noindent
Som du ser r de mycket lika katalogbeskrivningar. FlexCat inkluderar
kommentarerna i frn katalogbeskrivningen, ven dr de r meningslsa:
Observera kommentaren om strnglngden, som inte borde synas hr, eftersom
den informationen bara finns i katalogbeskrivningen.

Allt du behver gra nu r att fylla i informationen fr versionen (i stil
med @samp{$VER: HelloLocalWorld.catalog 1.1 (25.8.97)}), sprket p
katalogversttningen (@samp{Deutsch} fr tyska i det hr fallet),
koduppsttningen (som alltid br vara 0 fr tillfllet; se
Locale/OpenCatalog() fr mer information) och naturligtvis strngen.
FlexCat inkluderar den ursprungliga strngen som en kommentar, s att du
alltid vet som skall fyllas i. Slutligen skapar du katalogen med ett
kommando som:

@example
@samp{FlexCat HelloLocalWorld.cd Deutsch.ct CATALOG Deutsch.catalog}
@end example

@noindent
Observera att du inte behver sjlva programmet, eller kllkodsfilerna som
skapades med FlexCat, nr du skapar katalogerna! Du kan skapa nya kataloger
nr som helst. Det r vanligt att i distributioner skicka med en fil som
FlexCat.ct, s att anvndare kan gra sina egna versttningar.

Men vad hnder om du ndrar programmet senare? Redigera bara
katalogbeskrivningen och anvnd FlexCat fr att uppdatera
katalogversttningarna:

@example
@samp{FlexCat HelloLocalWorld.cd Deutsch.ct NEWCTFILE Deutsch.ct}
@end example

@noindent
Allt du behver gra nu r att verstta eventuella nya strngar.



@iftex
@vfill@eject
@end iftex

@node Installation
@chapter Installation
@cindex Installation
@cindex Systemkrav.
FlexCat r skrivet i ren ANSI-C (frutom lokaliseringen), s det br
fungera p vilken Amiga som helst, och frhoppningsvis ven p andra
datorer efter en omkompilering (lokaliseringen kommenteras bort i det
fallet). Detta gller ocks fr de skapade programmen: FlexCat skrevs med
sig sjlv. All distribuerad kllkodsbeskrivning br skapa program som kan
kras p vilken Amiga som helst, och ven vilken dator som helst
(naturligtvis mste du se till att variabeln LocaleBase har vrdet NULL i
det senare fallet). Lokalisering r dock bara mjligt med Workbench 2.1 och
hgre, eftersom @code{locale.library} inte finns tillgngligt i tidigare
versioner av operativsystemet.

Det r inte omjligt att lokalisera ett program utan @code{locale.library}:
Kllkodsbeskrivningarna @file{C_c_V20.sd} och @file{C_h_V20.sd} anvnder
@code{iffparse.library} (plus lite egen kod) istllet fr
@code{locale.library}, om @code{locale.library} inte r tillgngligt. Detta
gr det mjligt att lokalisera program som kr under Workbench 2.0.
@xref{C, C}.

Att installera FlexCat r enkelt: Kopiera bara programmet till en lda i
din kommandoskvg, och vlj ett stlle fr de kllkodsbeskrivningar du
behver (filer som heter ngot i stil med @file{xx_yy.sd}, dr @file{xx} r
programsprket). Du vill frmodligen stta miljvariabln
@var{FLEXCAT.PREFS} eller @var{FLEXCAT_SDDIR}. @xref{Program start,
programstart}.

Om du vill anvnda FlexCat i ett annat sprk n engelska behver du kopiera
motsvarande katalogfil. T.ex.@:, fr tyska, kopiera filen
@file{Catalogs/Deutsch/FlexCat.catalog} till
@file{Locale:Catalogs/Deutsch/} eller till
@file{ProgDir:Catalogs/Deutsch/}, dr @file{ProgDir:} r den lda dr
FlexCat finns. @xref{Using source, att anvnda FlexCat-kllkod}.



@iftex
@vfill@eject
@end iftex

@node Program start
@chapter Anvnda FlexCat i ett skal
@cindex CLI
@cindex Skal
@cindex Workbench
FlexCat r ett skalbaserat program, och kan inte anvndas frn Workbench.
Syntaxen r:

@example
FlexCat CDFILE/A,CTFILE,CATALOG/K,NEWCTFILE/K,SOURCES/M,
        WARNCTGAPS/S,NOOPTIM/S,FILL/S,FLUSH/S,NOBEEP/S,
        NOLANGTOLOWER/S,NOBUFFEREDIO/S,MODIFIED/S,QUIET/S
@end example

Notera att FlexCat inte anvnder de normala rutinerna fr att tolka
argumenten (fr portabilitetens skull). Detta gr framfr allt att de enda
nyckelod du kan (och mste) ange r CATALOG och NEWCTFILE (de som r av
typen "/K"), de andra kan inte anges, d de skulle tolkas som argument i
sig. Detta kommer att ndras, frmodligen i nsta version.

I och med version 1.9 har FlexCat ett enkelt system fr instllningar, som
lter dig ndra FlexCats normala beteende. @xref{Preferences,
instllningar}.

Vad argumenten anvnds till:

@table @strong
@cindex CDFILE
@item CDFILE
r namnet p den katalogbeskrivning som skall lsas. Denna mste alltid
anges. Observera att basnamnet fr kllkodsbeskrivningen skapas frn detta
argument, vilket gr det lgesknsligt. @xref{Source, kllkodsbeskrivning}.

@cindex CTFILE
@item CTFILE
r namnet p den katalogversttning som skall lsas. Denna behvs nr du
skapar en katalog, eller nr du uppdaterar en gammal katalogversttning
via NEWCTFILE-argumentet: FlexCat lser den gamla versttningen samt
katalogbeskrivningen och skapar en ny katalogversttning innehllande de
gamla strngarna, och kanske ngra tomma rader fr de nya strngarna.

@cindex CATALOG
@item CATALOG
r namnet p den katalogfil som skall skapas. Detta argument krver att
CTFILE ocks anges.

@cindex NEWCTFILE
@item NEWCTFILE
r namnet p den katalogversttning som skall skapas. FlexCat lser
strngarna frn CTFILE, om CTFILE angavs; strngar som saknas i
katalogversttningen erstts med tomma rader. (Den nya
katalogversttningen kommer bara att innehlla tomma rader som strngar om
CTFILE inte anges.)

@cindex SOURCES
@item SOURCES
r namnet p de kllkoder som skall skapas. Dessa anges i formatet
@samp{kllkod=mall}, dr @file{kllkod} r filen som ska skapas, och
@samp{mall} r namnet p den kllkodsbeskrivning som ska lsas.

Om kllkodsbeskrivningen inte kunde hittas, frsker FlexCat ppna en fil
med samma namn i ldan @file{ProgDir:lib}. (Ldan @file{lib} i den lda som
FlexCat finns i.) Du kan ndra denna frvalda lda genom att
stta miljvariabeln @var{FLECCAT_SDDIR}. Exempel:

@example
@samp{FlexCat FlexCat.cd FlexCat_Cat.c=Templates/C_c_V20.sd}
@end example

@noindent
letar efter filen @file{Templates/C_c_V20.sd} i den aktuella ldan. Om
denna fil inte kunde hittas, och miljvariablen @var{FLEXCAT_SDDIR} inte
var definierad, letar FlexCat efter
@file{ProgDir:lib/Templates/C_c_V20.sd}. Om @var{FLEXCAT_SDDIR} var
definierad och innehll till exempel @samp{Work:FlexCat}, letar FlexCat
efter @file{Work:FlexCat/Templates/C_c_V20.sd}.

@cindex WARNCTGAPS
@item WARNCTGAPS
Normalt sett varnar FlexCat inte om symboler saknas i
katalogversttningen. Med denna flagga kan du f FlexCat att visa sdana
varningar.

@cindex NOOPTIM
@item NOOPTIM
Om bda strngarna (orginalet i #?.cd, och versttningen i #?.ct) r
likadana, s antar FlexCat normalt sett att strngen inte behver skrivas
till katalogen, eftersom strngen d kan tas frn de inbyggda strngarna
istllet. Men om du av ngon anledning vill att ven dessa strngar skall
skrivas (eller: om du vill att alla strngar skall skrivas), anvnd NOOPTIM.

@cindex FILL
@item FILL
Denna finess r mycket anvndbar fr versttarna. Nr du arbetar p en
versttning kan en del strngar vara tomma, men du vill prova de
versttningar du redan har gjort. Olyckligtvis s skriver d alla
kataloggeneratorer tomma strngar, vilket skulle gra att t.ex.@: knappar
blir tomma.

En flagga fr att frbjuda tomma strngar r inte en bra lsning, eftersom
du d inte kan ha sdana om det behvs. Dessutom, ett illa skrivet program
kanske krver att alla strngar finns i katalogen (ven de tomma), t.ex.@:
fr att det inte finns ngra inbyggda strngar. Genom att anvnda
FILL-flaggan kan du tvinga FlexCat att skriva orginalstrngarna (frn
@file{#?.cd}-filen) varje gng den hittar en tom versttning, eller en
versttning som inte finns.

OBS: Detta br bara anvndas fr att prova versttningen. Frdiga
kataloger br alltid skapas utan ngon FILL-flagga!

@cindex FLUSH
@item FLUSH
Denna flagga r anvndbar nr du verstter och provar din versttning.
Eftersom AmigaOS inte direkt tar bort kataloger (och bibliotek,
teckensnitt, drivrutiner, etc.@:) frn minnet nr de inte lngre anvnds,
kan du behva tvinga systemet att ta bort dem (t.ex.@: genom att anvnda
@file{C:Avail FLUSH}) varje gng du vill att den nyskapade katalogen skall
lsas frn disk (istllet fr att kopian i minnet anvnds). Om du anger den
hr flaggan nr katalogen skapas, kommer FlexCat att ta bort alla oanvnda
saker frn minnet.

OBS: FLUSH fungerar bara nr du skapar en katalog. Annars kommer den att
ignoreras.

Example:

@example
@samp{FlexCat Test.cd Test.ct CATALOG Test.catalog FLUSH}
@end example

@cindex NOBEEP
@item NOBEEP
I och med version 1.9 blnker FlexCat skrmen fr att uppmrksamma dig om
problem som har ptrffats. Detta kan vara mycket anvndbart nr du
anvnver FlexCat frn en milj utan en normal utmatning (t.ex.@: om du
startar ett skript frn Opus eller ett annat program). Du kanske inte
tycker om dessa blnkningar (fast FlexCat r smart nog att bara blnka en
gng, ven om du fr 20 varingar). I s fall kan du anvnda NOBEEP-flaggan
fr att stnga av blnkandet.

@cindex NOLANGTOLOWER
@item NOLANGTOLOWER
Normalt konverterar FlexCat argumentet till #language till gemener genom att
anvnda en funktion i utility.library. Denna funktion anvnder
locale.library om det r installerat, men tydligen finns det felaktiga
versttningstabeller fr ngra sprk (till exempel tjeckiska), vilket kan
leda till en felaktig konvertering. Med den hr flaggan kan du undvika
problemet. Du br dock kontakta frfattaren av sprkfilerna s att dessa
fel rttas, eftersom andra program kan drabbas av samma problem. Kom ihg
att bara anvnda gemener fr #language om du anvnder den hr flaggan (och
anvnd den bara om det r absolut ndvndigt).

@cindex NOBUFFEREDIO
@item NOBUFFEREDIO
FlexCat anvnder buffrad IO. Detta kan gra FlexCat snabbare, men det r
inte skert. Du kan d anvnda den hr flaggan fr att anvnda obuffrad IO.
Anvnd den bara om det r ndvndigt.

@cindex MODIFIED
@item MODIFIED
Den hr flaggan gr att FlexCat bara skapar katalogen nr ngon av
kllfilerna, #?.cd och #?.ct, har ndrats sedan katalogen senast
kompilerades. Nr katalogen r nyare n kllfilerna avslutar FlexCat utan
att gra ngot. Den hr flaggan r anvndbar nr du vill skapa en
kommandofil fr att kompilera flera kataloger p en gng (till exempel fr
versttningen av stora program), och inte vill slsa tid p att kompilera
om kataloger som inte har ndrats. (Detta r allts ett enklare alternativ
till att anvnda ett make-program.)

@cindex QUIET
@item QUIET
Sger t FlexCat att hlla tyst om det inte r absolut ndvndigt. Det
betyder att du inte kommer att se ngra varningar. Fel kommer att
rapporteras som vanligt.

@end table

Fr fler exempel p kommandorader, se @ref{Survey, versikten}.




@iftex
@vfill@eject
@end iftex

@node Preferences
@chapter ndra FlexCats normala beteende
@cindex Instllningar
@cindex flexcat.prefs

I och med version 1.9 har FlexCat ett enkelt system fr instllningar.
Genom att anvnda miljvariabeln @var{FLEXCAT.PREFS} kan du ndra
programmets normala beteende.

Variabeln @var{FLEXCAT.PREFS} tolkas med dos.library:s ReadArgs()-funktion,
och slunda skall alla argument anges p en rad, dr argumenten separeras
med mellanslag. Mallen fr instllningarna ser ut som fljer:

@example
SDDIR/K,WARNCTGAPS/S,NOOPTIM/S,FILL/S,FLUSH/S,NOBEEP/S,QUIET/S
@end example

Fr mer information om dessa argument, @xref{Program start, programstart}.

En kommentar angende SDDIR: Nr kllkoden skapas letar FlexCat frst i den
aktuella ldan, sedan i ldorna som anges i instllningarna. Om detta
fortfarande inte lyckas, lses @var{FLEXCAT_SDDIR}, och slutligen ldan
@file{ProgDir:lib/}. Genom att anvnda bde instllningsvariabeln och
@var{FLEXCAT_SDDIR} kan du allts anvnda tv egna ldor fr
kllkodsbeskrivningar samtidigt.



@iftex
@vfill@eject
@end iftex

@node Description
@chapter Katalogbeskrivningar
@cindex Katalogbeskrivning
@cindex .cd
En katalogbeskrivning innehller fyra olika sorters rader.

@table @strong
@item Kommentarsrader
En rad om brjar med ett semikolon antas vara en kommentarsrad, och
ignoreras drmed. (Strngrader (se nedan) r ett undantag. De kan brja med
ett semikolon.)

@item Kommandorader
En rad som brjar med ett "#" (med samma undantag som ovan) antas vara
kommandorader. Fljande kommandon kan anvndas:

@table @code
@item #language <strng>
anger programmets frvalda sprk; det sprk som anvnds i
katalogbeskrivningen. Frvalt r @samp{#language english}.

@item #version <num>
anger versionsnumret fr katalogen som skall ppnas. Observera att detta
nummer mste stmma exakt, och inte vara samma eller hgre, som fr
@cite{Exec/OpenLibrary}. Undantaget r 0, vilket godtar vilken
katalogversion som helst. Frvalt r @samp{#version 0}.

Se @code{Locale/OpenCatalog} fr mer information om katalogsprket och
versionen.

@item #lengthbytes <num>
Sger t FlexCat att placera det givna antalet tecken fre en strng,
innehllande strngens lngd. Lngden r det antal tecken strngen tar upp,
frutom lngdtecknena och ett avslutande nolltecken. (Katalogfiler, och
drmed katalogstrngar kommer att ha ett avslutande nolltecken. Detta r
inte alltid sant fr de inbyggda strngarna, beroende p hur
kllkodsbeskrivningen ser ut.) @samp{<num>} mste vara mellan 0 och sizeof(
long ) = 4. Frvalt r @samp{#lengthbytes 0}.

@item #basename <strng>
Anger basnamnet fr programmet. @xref{Source, kllkodsbeskrivning}. Denna
strng anvnds istllet fr basnamnet frn kommandoradsargumentet CDFILE.
@xref{Program start, programstart}.
@end table

Kommandon r lgesknsliga.

@item Beskrivningsrader
deklarerar en strng. De ser ut som @samp{IDSTR (id/minlen/maxlen)}, dr
@samp{IDSTR} r en identifierare (en strng bestende av tecknena a-z, A-Z
0-9, samt @samp{_}); @samp{id} r ett unikt nummer (hrmed kallat ID) och
@samp{minlen}, samt @samp{maxlen} r strngens minimala respektive maximala
lngd. De tre sista talen behver inte anges (men tecknena @samp{(//)}
mste anges!), i vilket fall FlexCat vljer ett nummer, och stter inte
ngra begrnsningar p strngens lngd. Det r bst att inte ange ngra
ID-nummer om du inte absolut behver det. Dessa rader fljs av

@item Strngrader
@cindex Kontrolltecken
@cindex ASCII-kod
som innehller strngen, och inget annat. Dessa strngaar kan innehlla
vissa kontrolltecken, som brjar med ett bakstreck:

@table @samp
@item \b
Backsteg (ASCII 8)

@item \c
Kontrollsekvensstart (ASCII 155)

@item \e
Escape (ASCII 27)

@item \f
Sidmatning (ASCII 12)

@item \g
Blnk (ASCII 7)

@item \n
Radmatning (ASCII 10)

@item \r
Radretur (ASCII 13)

@item \t
Tab (ASCII 9)

@item \v
Vertikal tab (ASCII 11)

@item \)
Avslutande parantes, som kan behvas som en del av sekvensen @samp{(..)},
se @ref{Source, kllkodsbeskrivning}.

@item \\
Bakstreck

@item \xHH
Tecknet som anges av ASCII-koden @samp{HH}, dr @samp{HH} r hexadecimala
siffror.

@item \OOO
Tecknet som anges av ASCII-koden @samp{OOO}, dr @samp{OOO} r oktala
siffror.
@end table

Slutligen, ett ensamt bakstreck p slutet av raden anger att strngen
fortstter p nsta rad. Detta gr det mjligt att ange strngar av
godtycklig lngd; FlexCat gr inte ngra antanganden gllande strngens
lngd.

@end table

En strng anges allts av en beskrivningsrad, samt den fljande
strngraden. Ett exempel:

@example
    msgHello (/4/)
    Hello, this is english!\n
@end example

@noindent
@cindex FlexCat.cd
ID-numret saknas hr, s FlexCat vljer ett lmpligt nummer. Numret 4 sger
t FlexCat att den fljande strngen inte fr ha frre n fyra tecken, och
att den i vrigt kan ha godtycklig lngd. Se filen @file{FlexCat.cd} fr
ytterligare exempel.



@iftex
@vfill@eject
@end iftex

@node Translation
@chapter Katalogversttningar
@cindex Katalogversttning
@cindex .ct
Katalogversttningar pminner mycket om katalogbeskrivningar, frutom
att den innehller andra kommandon, samt ingen information om strng-ID och
lngd (dessa tas frn katalogversttningen). Alla strngar frn
katalogbeskrivningen mste finnas med i versttningen (FlexCat undviker
att skriva strngar som r identiska med orginalet till katalogen), och
inga fler identifierare fr finnas med. Man kan enkelt frskra sig om
detta genom att anvnda FlexCat fr att skapa nya
katalogversttningar. @xref{Survey, versikt}.

De kommandon som tillts i en katalogversttning r:

@table @code
@item ##version <strng>
Anger katalogens version i form av en versionsstrng i AmigaDOS-format.
Exempel:

@example
@samp{##version $VER: FlexCat.catalog 8.2 (25.8.97)}
@end example

Versionen p denna katalog r 8. Slunda mste katalogbeskrivningens
versionsnummer vara 0 eller 8.

Du kan erstta datumet (hr @samp{27.09.93}) med det speciella nyckelordet
@samp{$TODAY}. Nr katalogen skapas, kommer @samp{$TODAY} att ersttas med
det aktuella datumet (observera att bara den frsta frekomsten av @samp{$TODAY}
i @samp{$VER}-strngen kommer att behandlas). Om du vill att dina kataloger
alltid skall vara aktuella, ange allts:

@example
@samp{$VER: FlexCat.catalog 3.1 ($TODAY)}
@end example

@item ##rcsid $Date: <datum> <tid> $ $Revision: <rev> $
@itemx $Id: <namn> <datum> <tid> carlos Exp carlos $
kan anvndas tillsammans med ett revisionskontrollsystem istllet fr
##version (allt skall givetvis vara p en och samma rad). @samp{<datum>} r
datumet p formen @samp{/mm/dd}, @samp{<tid>} r tiden (ignoreras),
@samp{<rev>} r revisionen och @samp{<namn>} r namnet som anvnds i
versionstrngen.

@item ##name <namn>
finns med fr kompatibilitet med CatComp. Det erstter
@samp{<namn>}-argumentet i @code{##rcsid}-kommandot.

@item ##language <strng>
Katalogens sprk. Naturligtvis skall detta vara ett annat sprk n det som
anvnds i katalogbeskrivningen. Kommandona @samp{##language} och
@samp{##version} mste finnas med i en katalogversttning.

@item ##codeset <nummer>
Anvnds fr tillfllet inte, och mste vara 0. Detta r det frvalda vrdet.

@item ## chunk <ID> <strng>
Lgger till IFF-blocket @samp{<ID>} till katalogen, innehllande den
angivna <strng>. Anvnds oftast fr att lgga till en kommentar till en
katalog. Exempel:

@example
## chunk AUTH Tysk versttning av Jochen Wiedmann
@end example

@end table

@cindex Deutsch.ct
Enligt ovanstende ser allts vrt exempel ut s hr i
katalogversttningen:

@example
    msgHello
    Hallo, dies ist deutsch!\n
@end example

@noindent
Se @file{Deutsch.ct} fr ytterligare ett exempel p en katalogversttning.



@iftex
@vfill@eject
@end iftex

@node Source
@chapter Kllkodsbeskrivningar
@cindex Kllkodsbeskrivning
@cindex .sd
Detta r den speciella delen av FlexCat. Hittils har det inte varit ngot
som inte CatComp, KitCat och andra program ocks kan gra. Den skapade
kllkoden gr det enkelt att anvnda kataloger, utan att fr den skull
frlora flexibilitet. Vilket programsprk som helst br vara mjligt att
anvnda, och alla behov borde kunna uppfyllas. Det lter kanske som en
motsgelse, men FlexCats lsning p detta problem r
kllkodsbeskrivningarna, som innehller en mall fr hur kllkoden skall
skall se ut. Dessa kan redigeras p samma stt som katalogbeskrivningar och
katalogversttningar. Allts kan FlexCat generera i princip godtycklig kod.

Kllkodsbeskrivningarna genomsks efter vissa speciella symboler, som
erstts med vissa vrden. Mjliga symboler r bakstreckstecknena enligt
ovan, och ytterligare sekvenser som brjar med ett @samp{%}-tecken (detta
r vlbekant fr C-programmerare).

@table @samp
@item %b
r basnamnet p katalogbeskrivningen. @xref{Program start, programstart}.

@item %v
r versionsnumret p katalogbeskrivningen. Blanda inte ihop detta med
katalogversionen frn katalogversttningen.

@item %l
r katalogbeskrivningens sprk. Observera att detta matas in som en strng.
Se @samp{%s} nedan.

@item %n
r antalet strngar i katalogbeskrivningen.

@item %%
r tecknet @samp{%}.
@end table

De viktigaste r fljande sekvenser. De representerar katalogstrngarna p
olika stt. Rader innehllande en eller flera av fljande symboler upprepas
en gng fr varje strng.

@table @samp

@item %i
r identifieraren frn katalogbeskrivningen.

@item %nd
@itemx %nx
@itemx %nc
r ID-numret fr strngen i decimal, hexadecimal respektive oktal notation.
Numret @samp{n} sger t FlexCat hur mnga tecken ID-numret skall anvnda
(strngen fylls med noll till vnster till den nskade lngden). Om du inte
anger @samp{n} kommer ID-numret bara att anvnda det antal tecken som
behvs.

@item %e
r numret p den aktuella strngen. Rknaren brjar frn 0.

@item %s
r strngen sjlv. Hur denna skall matas in beror p programsprket som
anvnds, och kan kontrolleras med kommandona @samp{##stringtype} och
@samp{##shortstrings}.

@item %na
r strngens ID. Skillnaden mellan @samp{%na} och t.ex.@: @samp{%nx} r att
@samp{%na} genererar strngens ID @strong{separerad} till enstaka tecken:

@example
@samp{%2a} i kllkodsbeskrivningen resulterar i @samp{\x00\x20}
@end example

Om du inte anger @samp{n}, kommer ID-numret att bli fyra tecken.

@item %nt
r strngens lngd. Observera att det vrdet alltid r @strong{jmnt}.

@item %z
br anvndas tillsammans med @samp{%nt}. Eftersom @samp{%nt} alltid
resulterar i ett jmnt vrde, kan en beskrivningsrad som:

@example
static const char Block[] =
@{
     "%2a" "%2t" %s "%z"
@};
@end example

orsaka problem, speciellt nr man tolkar en sdan tabell, eftersom
@samp{%2t} kan vara jmn, medans strngens lngd r udda! Nr tabellen
tolkas kan du lsa eller hoppa ver ett tecken fr mycket (jag antar
konsekvenserna r knda). Fr att undvika detta introduerades @samp{%z}.
FlexCat erstter den med s mnga tecken (@samp{\x00}) som strngen saknar
fr att lngden skall bli jmn. Om strngen r tre tecken lng, ger
@samp{%nt} @samp{4}, och @samp{%z} lgger till en @samp{\x00}.

@item %(...)
matar in texten mellan paranteserna fr varje strng utom den sista. Detta
kan behvas i vektorer, om posterna i vektorn skall separeras med komma, men
den sista posten inte fr fljas av ett komma. Du kan anvnda @samp{(,)} i
s fall. Observera att inom paranteser erstts inte ngra
@samp{%}-sekvenser. Bakstrecksekvenser erstts dock fortfarande.

@end table

Kontrollsekvenserna @samp{%l} och @samp{%s} skapar strngar. Hur strngarna
ser ut beror p programsprket i frga. Drfr kan man ha kommandorader i
kllkodsbeskrivningen liknande dem i t.ex.@: katalogversttningen. Dessa
kommandon mste brja p frsta positionen p en rad, och det kan bara
finnas ett kommando per rad. Mjliga kommandon r:

@table @code
@item ##shortstrings
gr s att lnga strngar delas upp p flera raader. Detta r inte alltid
mjligt, eller kanske inte implementerad FlexCat. Slunda r det normala
att skapa en strng, som kanske r mycket lng.

@item ##stringtype <typ>
Talar om fr FlexCat hur strngarna skall se ut. Mjliga typer r:

@table @strong
@item None
Inga extra tecken; en ren kopia av strngen infogas, och inget annat.
Binra tecken (bakstegsekvenser) r inte mjliga.

@item C
skapar strngar i C-format. Strngarna fregs och fljs av tecknet
@samp{"}. Strngar delas med @samp{"\} p slutet av raden, och @samp{"} p
brjan av nsta rad. (Baksteget behvs i makron.) Binra tecken infogas
som @samp{\OOO}. @xref{C, C}.

@item Oberon
ser ut som strngtypen C, utom det avslutande baksteget p slutet av rader.
@xref{Oberon, Oberon}. Denna strngtyp rekommenderas ven fr Modula-2.

@item Assembler
Strngas skapas med @samp{dc.b}. Lsbara ASCII-tecken fregs och fljs av
tecknet @samp{'}; binra tecken infogas som @samp{$XX}. @xref{Assembler,
assembler}.

@item E
Strngar fregs och fljs av tecknet @samp{'}. Ett @samp{+}-tecken binder
samman strngar som har delats upp p flera rader. Binra tecken infogas
som i C.
@end table
@end table

Lt oss se p ett utdrag frn filen @file{C_h.sd}, som skapar en
inkluderingsfil fr programsprket C:

@example
##stringtype C
##shortstrings

/* Se till att vi bara inkluderas en gng. */
#ifndef %b_CAT_H
#define %b_CAT_H

/* Ls andra inkluderingsfiler. */
#include <exec/types.h>
#include <libraries/locale.h>

/* Funktionsprototyper */
extern void Open%bCatalog( struct Locale *, STRPTR );
extern void Close%bCatalog( void );
extern STRPTR Get%bString( LONG );

/* Definitioner fr identifierarna samt deras ID-nummer. */
/* Den hr raden kommer att upprepas fr varje strng.   */
#define %i %d

#endif
@end example

Fr den skvg som anvnds fr kllkodsbeskrivningar, se @ref{Program
start, programstart}.




@iftex
@vfill@eject
@end iftex

@node Using source
@chapter Anvnda kllkoden i egna program
@cindex Anvnda kllkoden
@cindex FlexCat-kllkod
Hur du anvnder kllkoden beror naturligtvis p vilken kllkod som skapas,
och drmed p kllkodsbeskrivningen som anvnds. Vad vi talar om hr r de
kllkodsbeskrivningar som fljer med FlexCat. @xref{Source,
kllkodbeskrivning}.

Alla kllkodsbeskrivningar borde gra det mjligt att anvnda programmen
utan @code{locale.library}. En global variabel kallad @samp{LocaleBase}
(@samp{_LocaleBase} fr assembler) mste dock finnas, och initieras med
NULL eller med ett anrop till @cite{Exec/OpenLibrary}. Lokalisering r inte
mjlig om @code{LocaleBase} r NULL, svida inte kllkodsbeskrivningen
@file{C_c_V20.sd} anvnds. Denna beskrivning mjliggr lokalisering under
AmigaOS 2.0 genom att erstta @code{locale.library} med
@code{iffparse.library} (plus lite egen kod). (En variabel kallad
@code{IFFParseBase} mste finnas fr att detta skall fungera, och den
behver initieras p liknande stt som @samp{LocaleBase}.) @xref{C, C}.
Programmeraren behver inte veta hur dessa bibliotek anvnds, utom nr han
skapar egna kllkodsbeskrivningar.

Det finns tre funktioner, och de r ganska enkla att anvnda.
@deffn {} OpenCatalog( locale, language )
Denna funktion ppnar eventuellt en katalog. Argumentet @code{locale} r en
pekare till en Locale-struktur, och @code{language} r en strng som
innehller namnet p det sprk fr vilket en katalog skall ppnas. I de
flesta fall r dessa bda @samp{NULL} eller @samp{NIL}, eftersom
anvndarens val inte anvnds annars. Se @cite{Locle/OpenCatalog} fr mer
information.

Icke objektorienderade sprk (C, assembler, Modula) anropar normalt sett
funktionen @code{OpenXXXCatalog}, dr XXX r basnamnet p applikationen:
Detta lter dig anvnda flera olika kataloger i ett och samma program.

Om anvndaren har @samp{Deutsch} och @samp{Franais} som de frvalda
sprken, och programmets basnamn r @samp{XXX}, s letar programmet efter
fljande filer:

@example
@file{ProgDir:Catalogs/Deutsch/XXX.catalog}
@file{Locale:Catalogs/Deutsch/XXX.catalog}
@file{ProgDir:Catalogs/Franais/XXX.catalog}
@file{Locale:Catalogs/Franais/XXX.catalog}
@end example

@noindent
dr @file{ProgDir:} r den lda dr programmet finns. (Ordningen mellan
@file{ProgDir:} och @file{Locale:} kan ndras fr att undvika en dialogruta
i stil med @samp{Mata in disketten YYY}.)

OpenCatalog r av typen void (en procedur fr Pascal-programmerare), och
returnerar drmed inte ngot vrde.
@end deffn

@deffn {} GetString( ID )
Returnerar en pekare till den strng som motsvaras av det givna ID:n i
katalogbeskrivningen. Dessa strngar gs av @code{locale.library}, och fr
inte modifieras.

Ett exempel kan vara anvndbart. Ta strngen frn exemplet med
katalogbeskrivningen, som kallades @code{msgHello}. Kllkodsbeskrivningen
deklarerar konstanten @samp{msgHello}, som representerar strngen. Denna
strng kan skrivas ut i C med:

@example
printf( "%s\n", GetString( msgHello ) );
@end example
@end deffn

@deffn {} CloseCatalog()
Den hr funktionen friar katalogen (allts det allokerade minnet) innan
programmet avslutas. Du kan anropa den hr funktionen nr som helst, ven
fre OpenCatalog anropas.
@end deffn

@menu
* C::         FlexCat-kllkod i C-program.
* C++::       FlexCat-kllkod i C++-program.
* Oberon::    FlexCat-kllkod i Oberon-program.
* Modula-2::  FlexCat-kllkod i Modula-2-program.
* Assembler:: FlexCat-kllkod i Assembler-program.
* E::         FlexCat-kllkod i E-program.
* Appendix::  Std fr flera kataloger.
@end menu



@iftex
@vfill@eject
@end iftex

@node C
@section FlexCat-kllkod i C-program
@cindex C
@cindex C_c_V20.sd
@cindex C_h.sd
@cindex C_c_V21.sd
@cindex AutoC_c.sd
@cindex AutoC_h.sd
@cindex Catcomp_h.sd
@cindex Cat2h_c.sd
@cindex Cat2h_h.sd
C-kllkoden bestr av tv delar: En @file{.c}-fil som skall kompileras och
anvndas som den r, samt en inkluderingsfil som ska inkluderas i alla
kllkodsfiler som anvnder katalogstrngar. Denna inkluderingsfil
definierar alla strngars ID:n som makron.

De C-kompilatorer jag kan (SAS/C, DICE och GCC) kan automatiskt ppna
bibliotek och initiera katalogerna. Du behver allts inte anropa
funktionerna @code{OpenCatalog} och @code{CloseCatalog}; kompilatorn gr
det t dig. Dessutom anropar @code{OpenCatalog} @code{GetString}-funktionen
fr alla katalogstrngar. Detta gr att du helt enkelt kan skriva
@samp{msgHello} istllet fr @samp{GetString( msgHello )}.

Om du definierar symbolen @code{LOCALIZE_V20} (@samp{-D LOCALIZE_V20} fr
DICE och GCC; @samp{DEF LOCALIZE_V20} fr SAS/C), kommer du att f ett
program som kan anvnda kataloger under OS 2.0: @code{locale.library}
erstts med @code{iffparse.library} i s fall. Ditt program behver d ven
ett argument som @samp{LANGUAGE}, s att anvndaren kan ange vilket sprk
som skall anvndas. Funktionen @code{InitXXXCatalog} (dr @samp{XXX} r
basnamnet p ditt program) behver anropas, med argumentet frn
@samp{LANGUAGE} som parameter. Denna parameter ignoreras naturligtvis om du
har @code{locale.library}. (Det vore mjligt att gra liknande saker under
OS 1.3, men jag vill inte stdja denna frldrade version lngre.)

Du frlorar lite funktionalitet med denna kllkodsbeskrivning: Till exempel
kan du inte skicka med en @code{Locale}-struktur till @code{OpenCatalog}.
De allra flesta programmen kommer dock inte att sakna ngot; andra behver
modifiera kllkodsbeskrivningen.

Fr ett exempel p ett program som anvnder dessa kllkodsbeskrivningen, se
@ref{Survey, versikten}.

@samp{OBS:}

I och med version 1.9 innehller arkivet kllkodsbeskrivningen
@file{CatComp_h.sd}, som kan anvndas av program som anvnder mer n en
katalog. Se den filen fr hur du kan uppdatera de andra
kllkodsbeskrivningarna.

Det finns ocks en ny kllkodsbeskrivning av Magnus Holmgren <cmh@@lls.se>.
Filerna @file{Cat2h_c.sd} och @file{Cat2h_h.sd} innehller
kllkodsbeskrivningar som genererar kod liknande den som genereras av Cat2h
av Nico Franois (och ven av Cat2Inc av Magnus Holmgren ;). Den anvnder
ett lite annorlunda stt fr att hantera strngar, som r kompakt och
snabbt.

Istllet fr att lagra alla strngar i en vektor, och ska igenom denna
varje gng (som CatComp normalt sett gr; man kan undvika detta dock),
lagras strngens ID i de tv frsta tecknena av strngen.
@code{GetString()}-funktionen, som d allts tar en strng som argument,
lser de tv frsta tecknena till ett lngord, och drmed r strngens ID
och den inbyggda strngen knda.

I och med version 1.9 kan FlexCat generera den hr sortens kod, via
kommandot @code{%a}. De inkluderade filerna anvnder @code{%2a}, och
anvnder allts bara tv byte fr ID-nummer per string (som Cat2h gr).
Detta torde rcka fr de flesta program. Om du ndrar lngden, kom ihg att
@code{GetString()}-funktionen ocks behver ndras.

Den genererade inkluderingsfilen definierar alla strngar, och
kllkodsfilen innehller kod fr att ppna och stnga katalogen (med
automatisk initiering fr SAS/C och DICE), och en lmplig
@code{GetString()}-funktion. En snabb titt p den genererade koden borde
vara nog fr att se alla detaljer, tycker jag.

Koden stdjer fr tillfllet inte flera kataloger, ej eller ndring av
versionsnummer eller inbyggt sprk. Enkelt att lgga till dock, om behovet
skulle uppst.



@iftex
@vfill@eject
@end iftex

@node C++
@section FlexCat-kllkod i C++-program.
@cindex C++
@cindex C++_cc.sd
@cindex C++_h.sd
@cindex C++_CatalogF.cc
@cindex C++_CatalogF.h
Att anvnda FlexCat-kllkod i C++-program r mycket enkelt: Nstan allt
grs av en speciell klass, som implementeras i filerna
@file{C++_CatalogF.cc} och @file{C++_CatalogF.h}. All du behver gra r
att dpa om dessa filer till @file{CatalogF.cc} och @file{CatalogF.h},
kompilera dem, och skapa ytterligare tv filer genom att anvnda
kllkodsbeskrivningarna @file{C++_cc.sd} och @file{C++_h.sd}. Den frsta
skapar filen med strngarna (som naturligtvis ocks mste kompileras), och
den andra filen kommer att inkluderas i ditt program. Ett C++-program som
anvnder FlexCat-kllkod kan se ut s hr:

@example
#include <iostream.h>
extern "C"
@{
#include <clib/exec_protos.h>
@}
#include "CatalogF.h"
#include "HelloLocalWorld_Cat.h"

struct LocaleBase *LocaleBase = 0;

int main()
@{ // Du mste ppna bibliteket hr, ven om din kompilator
   // stdjer automatisk ppning: Det kommer vanligtvis att
   // avsluta programmet om locale.library inte kunde ppnas.
   // Det r inte vad vi vill hr, eftersom vi d kommer att
   // anvnda de inbyggda strngarna istllet.
   LocaleBase = ( struct LocaleBase * )
       OpenLibrary( "locale.library", 38 );

   const CatalogF cat( 0, 0, HelloLocalWorld_ARGS );

   cout >> cat.GetString( msgHelloLocalWorld );

   if (LocaleBase)
       CloseLibrary(LocaleBase);
@}
@end example

En modifiering av GCCs @file{libauto.a} finns tillgnglig, som lter dig ta
bort raderna som gller variabeln @code{LocaleBase}.



@iftex
@vfill@eject
@end iftex

@node Oberon
@section FlexCat-kllkod i Oberon-program
@cindex Oberon
@cindex Oberon_V38.sd
@cindex Oberon_V39.sd
@cindex AmigaOberon
@cindex Oberon-A
Det finns ngra olika kllkodsbeskrivningar: @file{AmigaOberon.sd} r gjord
fr den aktuella versionen av kompilatorn @code{AmigaOberon}.
@file{Oberon_V39.sd} r fr ldre versioner, och @file{Oberon_V38.sd}
anvnder filen @file{Locale.mod} frn Hartmut Goebel. @file{Oberon-A.sd}
r, naturligtvis, fr @code{Oberon-A}.

Funktionsprototyperna r:

@example
XXX.OpenCatalog(loc: Locale.LocalePtr; language : ARRAY OF CHAR);
XXX.GetString(num: LONGINT): Exec.StrPtr;
XXX.CloseCatalog();
@end example

@noindent
dr @samp{XXX} r basnamnet frn kllkodsbeskrivningen.
@xref{Source, kllkodsbeskrivning}.

Till slut ett exempel p hur man anvnder FlexCat-kllkoden:

@example
MODULE HelloLocalWorld;

IMPORT  x:=HelloLocalWorld_Cat; Dos;

BEGIN
    x.OpenCatalog(NIL, "");

    Dos.PrintF("%s\n", x.GetString(x.msgHello));

    (* Katalogen kommer automatiskt att stngas *)
    (* nr programmet avslutas.                 *)
END Anything;
@end example


@iftex
@vfill@eject
@end iftex

@node Modula-2
@section FlexCat-kllkod i Modula-2-program.
@cindex Modula-2
@cindex Modula2Def.sd
@cindex Modula2Mod.sd
Modula-2 har ett modulkoncept liknande det i Oberon. Detta betyder att
funktionsnamnen r alltid samma. Till skillnad frn Oberon behver dock
Modula-2 en implementations- och en deklarationsmodul. Drfr behver du
skapa tv filer, genom att anvnda kllkodsbeskrivningarna
@file{Modula2Def.sd} och @file{Modula2Mod.sd}. Dessa r anpassade fr
kompilatorn M2Amiga. Observera att du ven behver filen
@file{OptLocalL.def} frn version 4.3 av M2Amiga.

Funktionsprototyperna r:

@example
PROCEDURE XXX.OpenCatalog(loc : ld.LocalePtr;
                          language : ARRAY OF CHAR);
PROCEDURE XXX.CloseCatalog();
PROCEDURE XXX.GetString(num : LONGINT) : ld.StrPtr;
@end example

@noindent
dr @samp{XXX} r basnamnet frn kllkodsbeskrivningen.
@xref{Source, kllkodsbeskrivning}.

Till slut ett exempel p hur man anvnder FlexCat-kllkoden:

@example
MODULE HelloLocalWorld;

IMPORT hl: HelloLocalWorldLocale,
       io: InOut;

BEGIN
    hl.OpenCatalog(NIL, "");

    io.WriteString(hl.GetString(hl.msgHello)); io.WriteLn;

    hl.CloseCatalog;
END HelloLocalWorld.
@end example


@iftex
@vfill@eject
@end iftex

@node Assembler
@section FlexCat-kllkod i assemblerprogram
@cindex Assembler
@cindex AztecAs_asm.sd
@cindex AztecAs_i.sd
Assemblerkllkoden har gjorts fr att anvndas med Aztec-assemblern. Denna
br dock inte skilja sig s mycket frn andra assemblatorer, och du br
kunna gra egna kllkodsbeskrivningar. Kllkoden bestr av tv delar: En
@file{.asm}-fil, som assembleras och lnkas, samt en @file{.i}-fil, som
definierar strngarnas ID, och mste inkluderas av de moduler som anvnder
dem.

Funktionsnamnen har ndrats lite fr att tillta anvndandet av
olika kataloger i en fil: Dessa r @samp{OpenXXXCatalog},
@samp{CloseXXXCatalog} och @samp{GetXXXString}, dr @samp{XXX} r basnamnet
frn kllkodsbeskrivningen. Konceptet har kopierats frn GadToolsBox, och
har visat sig fungera bra. @xref{Source, kllkodsbeskrivning}.

Som vanligt returneras funktionsresultatet i d0, och funktionerna ndrar
inte p registrena d2-d7 och a2-a7. OpenCatalog frvntar sig sina argument
i a0 (en pekare till Locale-strukturen) och a1 (en pekare till
sprkstrngen), vilka fr det mesta r NULL. GetString frvntar sig en
pekare i a0. Du behver inte bry dig om vad den pekar p.

Till slut ett exempel p hur man anvnder FlexCat-kllkoden:

@example
* HelloLocalWorld.asm

        include "XXX.i" ; Du mste inkludera denna. Den innehller
                        ; "xref OpenHelloLocalWorldCatalog", ...

        xref    _LVOOpenLibrary
        xref    _LVOCloseLibrary
        xref    _AbsExecBase

        dseg

LocNam: dc.b    "locale.library",0
        dc.l    _LocaleBase,4       ; Mste finnas med detta namn.

        cseg

main:   move.l  #38,d0              ; ppna locale.library
        lea     LocName,a1
        move.l  _AbsExecBase.a6
        jsr     _LVOOpenLibrary(a6)

* Avsluta INTE, om OpenLibrary misslyckas

        sub.l   a0,a0               ; ppna katalogen
        sub.l   a1,a1
        jsr     OpenHelloLocalWorldCatalog

        lea.l   msgHello,a0         ; Hmta en pekare till strngen
        jsr     GetHelloLocalWorldString
        jsr     PrintD0             ; och skriv ut strngen

Ende:
        jsr     CloseHelloLocalWorldCatalog ; Stng katalogen
        move.l  _LocaleBase,a1      ; Stng locale.library
        move.l  a1,d0               ; Denna test mste gras under 1.3
        beq     Ende1

        jsr     CloseLibrary
Ende1:
        rts
        end
@end example




@iftex
@vfill@eject
@end iftex

@node E
@section FlexCat-kllkod i E-program
@cindex E
@cindex E21b.sd
@cindex E30b.sd
I och med version 3.0 kan ett E-program delas upp i moduler. Den fljande
beskrivningen beskriver hur @file{E30b.sd} anvnds, som fungerar med E
version 3.0b eller hgre. (Version 3.0a hade allvarliga fel; fr tidigare
versioner kan man anvnda @file{E21b.sd}, vilket krver att man manuellt
infogar den genererade koden i den egna koden.)

@file{E30b.sd} skapar en modul som heter @file{Locale}, som innehller en
variabel, @code{cat}, av typen @samp{catalog_XXX}, dr @samp{XXX} r
basnamnet frn kllkodsbeskrivningen. @xref{Source, kllkodsbeskrivning}.
Filen @file{HelloLocalWorld.e} kan se ut ngot sdant hr:

@example
MODULE '*Locale'
    -> Anvnd den hr modulen.

DEF cat : PTR TO catalog_HelloLocalWorld
    -> Den hr variablen innehller alla strngarna i
    -> katalogen, samt ngra metoder. Du mste deklarera
    -> den i alla moduler som anvnder lokalisering, men
    -> initiera den bara i huvudmodulen.

PROC main()
    localebase := OpenLibrary('locale.library', 0)
        -> ppna locale.library; avsluta @strong{inte} om den
        -> inte kunde ppnas: Vi kommer att anvnda de
        -> inbyggda strngarna i s fall.

    NEW cat.create()
    cat.open()
        -> Som redan har nmnts, detta skall bara gras i
        -> huvudmodulen.

    WriteF('\s\n', cat.msg_Hello_world.getstr())
        -> cat.msg_Hello_world r en av de strngar som
        -> finns i cat. Den hr strngen deklarerar en
        -> metod, getstr(), som lser katalogen och
        -> returnerar en pekare till den lokaliserade
        -> strngen.

    cat.close()
    IF localebase THEN CloseLibrary(localebase)
ENDPROC
@end example



@iftex
@vfill@eject
@end iftex

@node Appendix
@section Std fr flera kataloger
@cindex CatComp_h.sd

De flesta kllkodsbeskrivningar som r tillgngliga fr tillfllet kan inte
anvndas i program som ppnar mer n en katalog. I senare distributioner
kommer detta skerligen att ndras, och uppdaterade kllkodsbeskrivningar
kommer att vara en del av de distributionerna.

Fr tillfllet fljer det med ett exempel av en sdan kllkodsbeskrivning.
Se @samp{CatComp_h.sd} fr att se hur beskrivningen kan justeras fr att
undvika att f flera symboler med samma namn och liknande. Med ngra f
ord: Anvnd @samp{%b} som prefix, suffix eller infix i varje namn som r en
viktig del av kllkoden (och som dessutom r globalt synliga). Om din
tabell med strngar heter @samp{String}, erstt den med @samp{%b_Strings},
och du kommer inte lngre att f flera symboler med samma namn.

@samp{CatComp_h.sd} producerar kllkod som liknar den som CatComp
genererar, och kan anvndas av de som vill anvnda FlexCat, men inte vill
nmnvrt ndra sina program.

@iftex
@vfill@eject
@end iftex

@node Future
@unnumbered Vidare utveckling av FlexCat
@cindex Framtid
@cindex FlexCat
@cindex Bidrag
ven om FlexCat verkar vara s gott som klart, har jag ngra poster kvar p
min "att gra" lista. Och jag r naturligtvis ppen fr frslag, tips eller
kritik. Speciellt kan jag lgga till nya strngtyper, eftersom detta kan
gras med mycket sm ndringar.

Jag vore mycket tacksam om ngon skickade mig nya kllkodsbeskrivningar och
om jag kunde inkludera dem i framtida distributioner. Vilket programsprk
som helst, och vilka utkningar som helst, under frutsttning att de har
visat sig fungera bra genom tester i riktiga program. Se @ref{Support,
support} fr kontaktadresser.

@node Support
@unnumbered FlexCat-support
@cindex Support

Fr programuppdateringar, besk hemsidan fr FlexCat vid:
@example
http://amiga.com.pl/flexcat/
@end example

Om du har ngra frslag eller felrapporter, skicka e-post till:


@example
carlos@@amiga.com.pl
@end example

eller via vanlig post:

@example
Marcin Orlowski
ul. Radomska 38
71-002 Szczecin
Poland
@end example

@iftex
@vfill@eject
@end iftex


@node Credits
@unnumbered Tack till
@cindex Tack till

@samp{Jochen Wiedmanns tack gr till:}

@table @strong
@item Albert Weinert
fr KitCat, fregngaren till FlexCat, som har gjort vrdefulla saker fr
mig, men till slut inte var flexibel nog, samt fr kllkodsbeskrivningen fr
Oberon.

@item Reinhard Spisser und Sebastiano Vigna
fr Amiga-versionen av TexInfo, som anvndes fr den hr dokumentationen.

@item The Free Software Foundation
fr den ursprungliga versionen av TexInfo, och mnga andra utmrkta
program.

@item Matt Dillon
fr DICE och speciellt DME.

@item Alessandro Galassi
fr den italienska versttningen.

@item Lionel Vintenat
fr kllkodsbeskrivningen fr E samt dess dokumentation, den franska
versttningen, samt fr felrapporter.

@item Antonio Joaqun Gomez Gonzalez (u0868551@@oboe.etsiig.uniovi.es)
fr kllkodsbeskrivningen fr C++, den spanska versttningen av bde
program och manual, och fr det mycket bra frslaget fr att snabba upp
GetString-funktionen.

@item Olaf Peters (op@@hb2.maus.de)
fr kllkodsbeskrivningen fr Modula-2.

@item Russ Steffen (steffen@@uwstout.edu)
fr att ha freslagit FLEXCAT_SDDIR-variabeln.

@item Lauri Aalto (kilroy@@tolsun.oulu.fi)
fr den finska versttningen.

@item Marcin Orlowski (carlos@@inet.com.pl)
fr den polska versttningen, och fr underhllet av det polska
locale-paketet.

@item Udo Schuermann (walrus@@wam.umd.edu)
fr att ha freslagit WARNCTGAPS-flaggan och ##chunk-kommandot.

@item Christian Hoj (cbh@@vision.auc.dk)
fr die dnische Quelltextbeschreibung

@item Personerna p #AmigaGer
fr att ha svarat p mnga dumma frgor, och fr mycket roligt. Till
exempel stefanb (Stefan Becker), PowerStat (Kai Hoffmann), ill (Markus
Illenseer), Quarvon (Jrgen Lang), ZZA (Bernhard Mllemann), Tron (Mathias
Scheler), mungo (Ignatios Souvlatzis), jow (Jrgen Weinelt) och Stargazer
(Petra Zeidler).

@item Commodore
fr Amiga och Kickstart 2.0. Fortstt utveckla Amigan, och jag kommer att
vara en Amiga-anvndare fr de nsta tta ren ocks. ;-)
@end table



@samp{Marcins tack gr till:}

@table @strong

@item Jochen Wiedmann
fr att ha skapat FlexCat.

@item Magnus Holmgren <cmh@@lls.se>
fr kllkodsbeskrivningen Cat2h.

@item Medlemmar i @strong{Amiga Translators' Organization} <http://ato.vapor.com/ato/>
fr att ha skapat nya versttningar, och uppdaterat existerande versttningar:

@table @strong
@item Serbiska
av Ljubomir Jankovic <lurch@@afrodita.rcub.bg.ac.yu>.

@item Tjeckiska
av Vit Sindlar <xsindl00@@stud.fee.vutbr.cz>.

@item Svenska
av Magnus Holmgren <cmh@@lls.se> och Hjalmar Wikholm <hjalle@@canit.se>.

@item Finska
uppdaterad av Mika Lundell <c71829@@uwasa.fi>.

@item Italienska
omarbetad av Luca Nora <ln546991@@silab.dsi.unimi.it> och Giovanni Addabbo
<gaddabbo@@imar.net>.

@end table

@end table


@iftex
@vfill@eject
@end iftex

@node History
@chapter Utveklingshistoria
@cindex Historia
@cindex ndringar

Utvecklingshistorien fr FlexCat finns i filen @file{FlexCat.history}, som
r en del av distributionsarkivet.


@headings off
@node Index
@unnumbered Index
@printindex cp

@contents

@bye
